Index: src/Actions/FillAction/FillRegularGridAction.cpp
===================================================================
--- src/Actions/FillAction/FillRegularGridAction.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Actions/FillAction/FillRegularGridAction.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,191 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * FillRegularGridAction.cpp
+ *
+ *  Created on: Jan 12, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Atom/atom.hpp"
+#include "Atom/CopyAtoms/CopyAtoms_withBonds.hpp"
+#include "CodePatterns/Log.hpp"
+#include "Descriptors/MoleculeOrderDescriptor.hpp"
+#include "Filling/Cluster.hpp"
+#include "Filling/Filler.hpp"
+#include "Filling/Inserter/Inserter.hpp"
+#include "Filling/Inserter/RandomInserter.hpp"
+#include "Filling/Mesh/CubeMesh.hpp"
+#include "Filling/Predicates/IsInsideSurface_FillPredicate.hpp"
+#include "Filling/Predicates/IsVoidNode_FillPredicate.hpp"
+#include "Filling/Predicates/Ops_FillPredicate.hpp"
+#include "LinkedCell/linkedcell.hpp"
+#include "LinkedCell/PointCloudAdaptor.hpp"
+#include "molecule.hpp"
+#include "MoleculeListClass.hpp"
+#include "Parser/FormatParserInterface.hpp"
+#include "Parser/FormatParserStorage.hpp"
+#include "Shapes/BaseShapes.hpp"
+#include "Tesselation/tesselation.hpp"
+#include "Tesselation/BoundaryLineSet.hpp"
+#include "Tesselation/BoundaryTriangleSet.hpp"
+#include "Tesselation/CandidateForTesselation.hpp"
+#include "World.hpp"
+
+
+#include <algorithm>
+#include <iostream>
+#include <string>
+#include <vector>
+
+#include "Actions/FillAction/FillRegularGridAction.hpp"
+
+using namespace MoleCuilder;
+
+// and construct the stuff
+#include "FillRegularGridAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr FillRegularGridAction::performCall() {
+  typedef std::vector<atom*> AtomVector;
+
+  // obtain information
+  getParametersfromValueStorage();
+
+  // get all present atoms for UndoState
+  AtomVector presentatoms = World::getInstance().getAllAtoms();
+
+  // get the filler molecule and move to origin
+  const std::vector< molecule *> molecules = World::getInstance().getSelectedMolecules();
+  if (molecules.size() != 1) {
+    ELOG(1, "No exactly one molecule selected, aborting,");
+    return Action::failure;
+  }
+  molecule *filler = *(molecules.begin());
+  LOG(1, "INFO: Chosen molecule has " << filler->size() << " atoms.");
+
+  // check for selected molecules and create surfaces from them
+  std::vector<atom *> atoms(World::getInstance().getSelectedAtoms());
+  FillPredicate * surface_predicate = NULL;
+  LinkedCell_deprecated * LC = NULL;
+  Tesselation * TesselStruct = NULL;
+  if (params.SphereRadius != 0.) {
+    if ( molecules.size() == 0) {
+      ELOG(1, "You have given a sphere radius " << params.SphereRadius
+          << " != 0, but have not select any molecules.");
+    }
+    // create adaptor for the selected atoms
+    PointCloudAdaptor< std::vector<atom *> > cloud(&atoms, std::string("Selected atoms"));
+
+    // create tesselation
+    LC = new LinkedCell_deprecated(cloud, 2.*params.SphereRadius);
+    TesselStruct = new Tesselation;
+    (*TesselStruct)(cloud, params.SphereRadius);
+
+    // and create predicate
+    surface_predicate = new FillPredicate( IsInsideSurface_FillPredicate( *TesselStruct, *LC ) );
+  }
+
+  // create predicate, mesh, and filler
+  bool successflag = false;
+  {
+    FillPredicate *voidnode_predicate = new FillPredicate(
+        IsVoidNode_FillPredicate(
+            Sphere(zeroVec, params.mindistance)
+            )
+        );
+    FillPredicate Andpredicate = (*voidnode_predicate);
+    if (surface_predicate != NULL)
+      Andpredicate = (Andpredicate) && !(*surface_predicate);
+    Mesh *mesh = new CubeMesh(params.counts, params.offset, World::getInstance().getDomain().getM());
+    Inserter *inserter = new Inserter(
+        Inserter::impl_ptr(
+            new RandomInserter(
+                params.RandAtomDisplacement,
+                params.RandMoleculeDisplacement,
+                params.DoRotate)
+            )
+        );
+
+    // fill
+    {
+      Filler *fillerFunction = new Filler(*mesh, Andpredicate, *inserter);
+      ClusterInterface::Cluster_impl cluster( new Cluster( filler->getAtomIds(), filler->getBoundingShape()) );
+      CopyAtoms_withBonds copyMethod;
+      successflag = (*fillerFunction)(copyMethod, cluster);
+      delete fillerFunction;
+    }
+
+    // remove
+    delete mesh;
+    delete inserter;
+    delete voidnode_predicate;
+    delete surface_predicate;
+    delete LC;
+    delete TesselStruct;
+  }
+
+  // generate list of newly created atoms
+  // (we can in general remove more quickly from a list than a vector)
+  AtomVector filleratoms = World::getInstance().getAllAtoms();
+//  LOG(0, filleratoms.size() << " atoms are present.");
+  std::list<atom *> filleratoms_list;
+  std::copy( filleratoms.begin(),  filleratoms.end(), std::back_inserter( filleratoms_list ));
+//  LOG(0, filleratoms_list.size() << " atoms have been copied.");
+  for (AtomVector::const_iterator iter = presentatoms.begin();
+      iter != presentatoms.end();
+      ++iter) {
+    filleratoms_list.remove(*iter);
+  }
+//  LOG(0, filleratoms_list.size() << " atoms left after removal.");
+  filleratoms.clear();
+  std::copy(filleratoms_list.begin(), filleratoms_list.end(), std::back_inserter( filleratoms ));
+
+//  LOG(0, filleratoms.size() << " atoms have been inserted.");
+
+  if (successflag)
+    return Action::state_ptr(new FillRegularGridState(filleratoms,params));
+  else
+    return Action::failure;
+}
+
+Action::state_ptr FillRegularGridAction::performUndo(Action::state_ptr _state) {
+//  FillRegularGridState *state = assert_cast<FillRegularGridState*>(_state.get());
+//
+//  BOOST_FOREACH(atom *_atom, state->filleratoms) {
+//    World::getInstance().destroyAtom(Walker);
+//  }
+//
+//  // as atoms and atoms from state are removed, we have to create a new one
+//  std::vector<atom*> filleratoms;
+//  return Action::state_ptr(new FillRegularGridState(filleratoms,state->params));
+  return Action::failure;
+}
+
+Action::state_ptr FillRegularGridAction::performRedo(Action::state_ptr _state){
+  //FillRegularGridState *state = assert_cast<FillRegularGridState*>(_state.get());
+
+  return Action::failure;
+  //return Action::state_ptr(_state);
+}
+
+bool FillRegularGridAction::canUndo() {
+  return false;
+}
+
+bool FillRegularGridAction::shouldUndo() {
+  return false;
+}
+/** =========== end of function ====================== */
Index: src/Actions/FillAction/FillRegularGridAction.def
===================================================================
--- src/Actions/FillAction/FillRegularGridAction.def	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Actions/FillAction/FillRegularGridAction.def	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,36 @@
+/*
+ * FillRegularGridAction.def
+ *
+ *  Created on: Jan 20, 2012
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class atom;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (Vector)(Vector)(double)(double)(double)(double)(bool)
+#define paramtokens ("mesh-size")("mesh-offset")("min-distance")("tesselation-radius")("random-atom-displacement")("random-molecule-displacement")("DoRotate")
+#define paramdescriptions ("number of points per axis")("offset to start of partition, must be in [0,1)")("Minimum distance to other atoms")("radius of rolling sphere in tesselating selected molecule's surfaces")("magnitude of random atom displacement")("magnitude of random molecule displacement")("whether to rotate or not")
+#define paramdefaults (NODEFAULT)("0.,0.,0.")("1.")("0.")("0.")("0.")("0")
+#define paramreferences (counts)(offset)(mindistance)(SphereRadius)(RandAtomDisplacement)(RandMoleculeDisplacement)(DoRotate)
+
+#define statetypes (std::vector<atom *>)
+#define statereferences (filleratoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Fill
+#define MENUNAME "fill"
+#define MENUPOSITION 1
+#define ACTIONNAME RegularGrid
+#define TOKEN "fill-regular-grid"
+
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "\
+fill the domain via a regularly sparsed grid of insertion points with the \
+currently selected molecule. If atoms are selected, too, they are surrounded by \
+a tesselated surface and only outside of the tesselation is filled."
+#undef SHORTFORM
Index: src/Actions/FillAction/FillRegularGridAction.hpp
===================================================================
--- src/Actions/FillAction/FillRegularGridAction.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Actions/FillAction/FillRegularGridAction.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,22 @@
+/*
+ * FillRegularGridAction.hpp
+ *
+ *  Created on: Jan 12, 2012
+ *      Author: heber
+ */
+
+#ifndef FILLREGULARGRIDACTION_HPP
+#define FILLREGULARGRIDACTION_HPP
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "FillRegularGridAction.def"
+#include "Action_impl_header.hpp"
+
+#endif // FILLREGULARGRIDACTION_HPP
Index: src/Actions/GlobalListOfActions.hpp
===================================================================
--- src/Actions/GlobalListOfActions.hpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Actions/GlobalListOfActions.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -105,5 +105,6 @@
 	(SelectionNotAllAtomsInsideCuboid) \
 	(SelectionAtomById) \
-	(FragmentationFragmentation)
+	(FragmentationFragmentation) \
+	(FillRegularGrid)
 
 #endif /* GLOBALLISTOFACTIONS_HPP_ */
Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Actions/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -52,4 +52,5 @@
   ${ATOMACTIONSOURCE} \
   ${CMDACTIONSOURCE} \
+  ${FILLACTIONSOURCE} \
   ${FRAGMENTATIONACTIONSOURCE} \
   ${GRAPHACTIONSOURCE} \
@@ -67,4 +68,5 @@
   ${ATOMACTIONHEADER} \
   ${CMDACTIONHEADER} \
+  ${FILLACTIONHEADER} \
   ${FRAGMENTATIONACTIONHEADER} \
   ${GRAPHACTIONHEADER} \
@@ -82,4 +84,5 @@
   ${ATOMACTIONDEFS} \
   ${CMDACTIONDEFS} \
+  ${FILLACTIONDEFS} \
   ${FRAGMENTATIONACTIONDEFS} \
   ${GRAPHACTIONDEFS} \
@@ -173,4 +176,12 @@
   Actions/CommandAction/VersionAction.def \
   Actions/CommandAction/WarrantyAction.def
+
+FILLACTIONSOURCE = \
+	Actions/FillAction/FillRegularGridAction.cpp
+FILLACTIONHEADER = \
+	Actions/FillAction/FillRegularGridAction.hpp
+FILLACTIONDEFS = \
+	Actions/FillAction/FillRegularGridAction.def
+
 
 FRAGMENTATIONACTIONSOURCE = \
Index: src/Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -54,6 +54,6 @@
   LOG(1, "Selecting all atoms inside a rotated " << RotationMatrix << " cuboid at " << params.position << " and extension of " << params.extension << ".");
   Shape s = translate(transform(stretch(Cuboid(),params.extension),RotationMatrix),params.position);
-  std::vector<atom *> selectedAtoms = World::getInstance().getAllAtoms(AtomsBySelection() && AtomByShape(s));
-  World::getInstance().selectAllAtoms(AtomByShape(s));
+  std::vector<atom *> selectedAtoms = World::getInstance().getAllAtoms(AtomsBySelection() && AtomsByShape(s));
+  World::getInstance().selectAllAtoms(AtomsByShape(s));
   LOG(0, World::getInstance().countSelectedAtoms() << " atoms selected.");
   return Action::state_ptr(new SelectionAllAtomsInsideCuboidState(selectedAtoms, s, params));
@@ -63,5 +63,5 @@
   SelectionAllAtomsInsideCuboidState *state = assert_cast<SelectionAllAtomsInsideCuboidState*>(_state.get());
 
-  World::getInstance().unselectAllAtoms(AtomByShape(state->s));
+  World::getInstance().unselectAllAtoms(AtomsByShape(state->s));
   BOOST_FOREACH(atom *_atom, state->selectedAtoms)
     World::getInstance().selectAtom(_atom);
@@ -74,5 +74,5 @@
   RealSpaceMatrix RotationMatrix;
 
-  World::getInstance().selectAllAtoms(AtomByShape(state->s));
+  World::getInstance().selectAllAtoms(AtomsByShape(state->s));
 
   return Action::state_ptr(_state);
Index: src/Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -49,6 +49,6 @@
   LOG(1, "Selecting all atoms inside a sphere at " << params.position << " with radius " << params.radius << ".");
   Shape s = translate(resize(Sphere(),params.radius),params.position);
-  std::vector<atom *> selectedAtoms = World::getInstance().getAllAtoms(AtomsBySelection() && AtomByShape(s));
-  World::getInstance().selectAllAtoms(AtomByShape(s));
+  std::vector<atom *> selectedAtoms = World::getInstance().getAllAtoms(AtomsBySelection() && AtomsByShape(s));
+  World::getInstance().selectAllAtoms(AtomsByShape(s));
   LOG(0, World::getInstance().countSelectedAtoms() << " atoms selected.");
   return Action::state_ptr(new SelectionAllAtomsInsideSphereState(selectedAtoms, s, params));
@@ -58,5 +58,5 @@
   SelectionAllAtomsInsideSphereState *state = assert_cast<SelectionAllAtomsInsideSphereState*>(_state.get());
 
-  World::getInstance().unselectAllAtoms(AtomByShape(state->s));
+  World::getInstance().unselectAllAtoms(AtomsByShape(state->s));
   BOOST_FOREACH(atom *_atom, state->selectedAtoms)
     World::getInstance().selectAtom(_atom);
@@ -68,5 +68,5 @@
   SelectionAllAtomsInsideSphereState *state = assert_cast<SelectionAllAtomsInsideSphereState*>(_state.get());
 
-  World::getInstance().selectAllAtoms(AtomByShape(state->s));
+  World::getInstance().selectAllAtoms(AtomsByShape(state->s));
 
   return Action::state_ptr(_state);
Index: src/Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -53,6 +53,6 @@
   LOG(1, "Unselecting all atoms inside a rotated " << RotationMatrix << " cuboid at " << params.position << " and extension of " << params.extension << ".");
   Shape s = translate(transform(stretch(Cuboid(),params.extension),RotationMatrix),params.position);
-  std::vector<atom *> unselectedAtoms = World::getInstance().getAllAtoms((!AtomsBySelection()) && AtomByShape(s));
-  World::getInstance().unselectAllAtoms(AtomByShape(s));
+  std::vector<atom *> unselectedAtoms = World::getInstance().getAllAtoms((!AtomsBySelection()) && AtomsByShape(s));
+  World::getInstance().unselectAllAtoms(AtomsByShape(s));
   LOG(0, World::getInstance().countSelectedAtoms() << " atoms remain selected.");
   return Action::state_ptr(new SelectionNotAllAtomsInsideCuboidState(unselectedAtoms, s, params));
@@ -62,5 +62,5 @@
   SelectionNotAllAtomsInsideCuboidState *state = assert_cast<SelectionNotAllAtomsInsideCuboidState*>(_state.get());
 
-  World::getInstance().selectAllAtoms(AtomByShape(state->s));
+  World::getInstance().selectAllAtoms(AtomsByShape(state->s));
   BOOST_FOREACH(atom *_atom, state->unselectedAtoms)
     World::getInstance().unselectAtom(_atom);
@@ -73,5 +73,5 @@
   RealSpaceMatrix RotationMatrix;
 
-  World::getInstance().unselectAllAtoms(AtomByShape(state->s));
+  World::getInstance().unselectAllAtoms(AtomsByShape(state->s));
 
   return Action::state_ptr(_state);
Index: src/Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -49,6 +49,6 @@
   LOG(1, "Unselecting all atoms inside a sphere at " << params.position << " with radius " << params.radius << ".");
   Shape s = translate(resize(Sphere(),params.radius),params.position);
-  std::vector<atom *> unselectedAtoms = World::getInstance().getAllAtoms((!AtomsBySelection()) && AtomByShape(s));
-  World::getInstance().unselectAllAtoms(AtomByShape(s));
+  std::vector<atom *> unselectedAtoms = World::getInstance().getAllAtoms((!AtomsBySelection()) && AtomsByShape(s));
+  World::getInstance().unselectAllAtoms(AtomsByShape(s));
   LOG(0, World::getInstance().countSelectedAtoms() << " atoms remain selected.");
   return Action::state_ptr(new SelectionNotAllAtomsInsideSphereState(unselectedAtoms, s, params));
@@ -58,5 +58,5 @@
   SelectionNotAllAtomsInsideSphereState *state = assert_cast<SelectionNotAllAtomsInsideSphereState*>(_state.get());
 
-  World::getInstance().selectAllAtoms(AtomByShape(state->s));
+  World::getInstance().selectAllAtoms(AtomsByShape(state->s));
   BOOST_FOREACH(atom *_atom, state->unselectedAtoms)
     World::getInstance().unselectAtom(_atom);
@@ -68,5 +68,5 @@
   SelectionNotAllAtomsInsideSphereState *state = assert_cast<SelectionNotAllAtomsInsideSphereState*>(_state.get());
 
-  World::getInstance().unselectAllAtoms(AtomByShape(state->s));
+  World::getInstance().unselectAllAtoms(AtomsByShape(state->s));
 
   return Action::state_ptr(_state);
Index: src/Atom/CopyAtoms/CopyAtomsInterface.hpp
===================================================================
--- src/Atom/CopyAtoms/CopyAtomsInterface.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Atom/CopyAtoms/CopyAtomsInterface.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,90 @@
+/*
+ * CopyAtomsInterface.hpp
+ *
+ *  Created on: Mar 17, 2012
+ *      Author: heber
+ */
+
+#ifndef COPYATOMSINTERFACE_HPP_
+#define COPYATOMSINTERFACE_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <vector>
+
+class atom;
+class CopyAtomsInterfaceTest;
+
+/** This class defines a general interface for functors that copy a Vector of Atoms.
+ *
+ * I.e. we can implement here multiple ways of copying a vector of atoms, with or
+ * without bonds, with or without saturation, ...
+ *
+ */
+class CopyAtomsInterface
+{
+  /// grant unit test access
+  friend class CopyAtomsInterfaceTest;
+public:
+  typedef std::vector<atom*> AtomVector;
+  typedef std::vector<const atom*> ConstAtomVector;
+
+  /** Constructor.
+   *
+   */
+  CopyAtomsInterface()
+  {}
+
+  /** Destructor.
+   *
+   */
+  virtual ~CopyAtomsInterface()
+  {}
+
+  /** Function that just stores given atoms in CopyAtomsInterface::OriginalAtoms.
+   *
+   * We reset ourselves.
+   * We initialize CopyAtomsInterface::CopiedAtoms with the size of \a _atoms
+   * but NULL entities.
+   *
+   * \note If you override this function, always first call the implementation
+   * in the original class, then continue with implementation in derived class.
+   *
+   * @param _atoms atoms to copy
+   */
+  virtual void operator()(const AtomVector &_atoms)
+  {
+    // clear ourselves
+    reset();
+    CopiedAtoms.resize(_atoms.size(), NULL);
+  }
+
+  /** Getter for CopiedAtoms to allow outside transformations.
+   *
+   * @return CopiedAtoms
+   */
+  AtomVector& getCopiedAtoms() {
+    return CopiedAtoms;
+  }
+
+private:
+  /// forbid copy cstor as it may change class behavior
+  CopyAtomsInterface(const CopyAtomsInterface &);
+
+  /** Internal helper to reset all member variables.
+   *
+   */
+  void reset()
+  {
+    CopiedAtoms.clear();
+  }
+
+protected:
+  //!> set of copied atoms, this is to allow later transformations in derived classes
+  AtomVector CopiedAtoms;
+};
+
+#endif /* COPYATOMSINTERFACE_HPP_ */
Index: src/Atom/CopyAtoms/CopyAtoms_SaturateDanglingBonds.cpp
===================================================================
--- src/Atom/CopyAtoms/CopyAtoms_SaturateDanglingBonds.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Atom/CopyAtoms/CopyAtoms_SaturateDanglingBonds.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,34 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * CopyAtoms_SaturateDanglingBonds.cpp
+ *
+ *  Created on: Mar 17, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "CopyAtoms_SaturateDanglingBonds.hpp"
+
+#include "CodePatterns/Assert.hpp"
+
+template <class BondCopier>
+void CopyAtoms_SaturateDanglingBonds<BondCopier>::operator()(const AtomVector &_atoms)
+{
+  ASSERT( 0,
+      "CopyAtoms_SaturateDanglingBonds::operator() -  not implemented yet, see molecule::AddHydrogenReplacementAtom.");
+
+  BondCopier::operator()(_atoms);
+}
Index: src/Atom/CopyAtoms/CopyAtoms_SaturateDanglingBonds.hpp
===================================================================
--- src/Atom/CopyAtoms/CopyAtoms_SaturateDanglingBonds.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Atom/CopyAtoms/CopyAtoms_SaturateDanglingBonds.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,43 @@
+/*
+ * CopyAtoms_SaturateDanglingBonds.hpp
+ *
+ *  Created on: Mar 17, 2012
+ *      Author: heber
+ */
+
+#ifndef COPYATOMS_SATURATEDANGLINGBONDS_HPP_
+#define COPYATOMS_SATURATEDANGLINGBONDS_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Atom/CopyAtoms/CopyAtomsInterface.hpp"
+
+/** This class extends the implementation of CopyAtoms_withBonds to not only
+ * copy the atoms and their bonds but also to saturate any dangling ones with
+ * additional hydrogen atoms.
+ *
+ */
+template <class BondCopier>
+class CopyAtoms_SaturateDanglingBonds : public BondCopier, virtual public CopyAtomsInterface
+{
+public:
+  /** Destructor.
+   *
+   */
+  virtual ~CopyAtoms_SaturateDanglingBonds()
+  {}
+
+  /** Function to saturate any dangling bonds with additional hydrogen.
+   *
+   * @param _atoms vector of atoms to copy
+   */
+  virtual void operator()(const AtomVector &_atoms);
+};
+
+
+
+#endif /* COPYATOMS_SATURATEDANGLINGBONDS_HPP_ */
Index: src/Atom/CopyAtoms/CopyAtoms_Simple.hpp
===================================================================
--- src/Atom/CopyAtoms/CopyAtoms_Simple.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Atom/CopyAtoms/CopyAtoms_Simple.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,51 @@
+/*
+ * CopyAtoms_Simple.hpp
+ *
+ *  Created on: Mar 17, 2012
+ *      Author: heber
+ */
+
+#ifndef COPYATOMS_SIMPLE_HPP_
+#define COPYATOMS_SIMPLE_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <algorithm>
+#include <boost/bind.hpp>
+
+#include "Atom/atom.hpp"
+#include "Atom/CopyAtoms/CopyAtomsInterface.hpp"
+
+/** This is an implementation of CopyAtomsInterface that simply copies each atom.
+ *
+ */
+class CopyAtoms_Simple : public CopyAtomsInterface
+{
+public:
+  /** Destructor.
+   *
+   */
+  virtual ~CopyAtoms_Simple()
+  {}
+
+  /** This operator simply copies all the atoms in \a CopyAtomsInterface::atoms and
+   * translates them to the same position.
+   *
+   * @param _atoms atoms to copy
+   */
+  virtual void operator()(const AtomVector &_atoms)
+  {
+    CopyAtomsInterface::operator()(_atoms);
+
+    // copy each atom
+    std::transform(_atoms.begin(), _atoms.end(), CopiedAtoms.begin(),
+        boost::bind(&atom::clone, _1) );
+  }
+};
+
+
+#endif /* COPYATOMS_SIMPLE_HPP_ */
Index: src/Atom/CopyAtoms/CopyAtoms_withBonds.cpp
===================================================================
--- src/Atom/CopyAtoms/CopyAtoms_withBonds.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Atom/CopyAtoms/CopyAtoms_withBonds.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,81 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * CopyAtoms_withBonds.cpp
+ *
+ *  Created on: Mar 17, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "CopyAtoms_withBonds.hpp"
+
+#include "Bond/bond.hpp"
+#include "CodePatterns/Assert.hpp"
+#include "CodePatterns/Log.hpp"
+#include "WorldTime.hpp"
+
+void CopyAtoms_withBonds::operator()(const AtomVector &_atoms)
+{
+  CopyAtoms_Simple::operator()(_atoms);
+
+  // create LookupMap
+  LookupMap_t LookupMap = createLookup(_atoms);
+  ASSERT( LookupMap.size() == _atoms.size(),
+      "CopyAtoms_withBonds::operator() - Lookupmap and original AtomVectors differ in size: "
+      +toString(LookupMap.size())+" != "+toString(_atoms.size())+".");
+  ASSERT( LookupMap.size() == CopiedAtoms.size(),
+      "CopyAtoms_withBonds::operator() - Lookupmap and copied AtomVectors differ in size.: "
+      +toString(LookupMap.size())+" != "+toString(CopiedAtoms.size())+".");
+
+  // then go through the bonds of each original atom
+  for (AtomVector::const_iterator original_iter = _atoms.begin();
+      original_iter != _atoms.end(); ++original_iter) {
+    const BondList ListOfBonds = (*original_iter)->getListOfBonds();
+    for(BondList::const_iterator iter = ListOfBonds.begin(); iter != ListOfBonds.end(); ++iter) {
+      // check both bond partners have been copied
+      const bond * const Binder = *iter;
+      if (*original_iter == Binder->leftatom) {
+        LookupMap_t::const_iterator leftiter = LookupMap.find(Binder->leftatom);
+        LookupMap_t::const_iterator rightiter = LookupMap.find(Binder->rightatom);
+        if ((leftiter !=  LookupMap.end()) && (rightiter !=  LookupMap.end())) {
+          // create new bond, copy its properties, and register with both copies
+          atom * const LeftAtom = leftiter->second;
+          atom * const RightAtom = rightiter->second;
+          bond * const NewBond = LeftAtom->addBond(WorldTime::getTime(), RightAtom);
+          LOG(3, "DEBUG: Creating copy bond between original " << Binder->leftatom->getId()
+              << " and " << Binder->rightatom->getId() << ": " << *NewBond << ".");
+          NewBond->BondDegree = Binder->BondDegree;
+          NewBond->Cyclic = Binder->Cyclic;
+          NewBond->Type = Binder->Type;
+        } else {
+          LOG(4, "DEBUG: Skipping bond between original atoms " << Binder->leftatom->getId()
+              << " and " << Binder->rightatom->getId() << " as one of them is not present in copied atoms.");
+        }
+      } else {
+        LOG(4, "DEBUG: Skipping bond between original atoms " << Binder->leftatom->getId()
+            << " and " << Binder->rightatom->getId() << " due to wrong order.");
+      }
+    }
+  }
+
+  // print copied atoms
+  if (DoLog(3))
+    for (AtomVector::const_iterator copy_iter = CopiedAtoms.begin();
+        copy_iter != CopiedAtoms.end(); ++copy_iter) {
+      const BondList ListOfBonds = (*copy_iter)->getListOfBonds();
+      LOG(3, "DEBUG: List of bonds for " << **copy_iter << ": " << ListOfBonds << ".");
+    }
+}
Index: src/Atom/CopyAtoms/CopyAtoms_withBonds.hpp
===================================================================
--- src/Atom/CopyAtoms/CopyAtoms_withBonds.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Atom/CopyAtoms/CopyAtoms_withBonds.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,74 @@
+/*
+ * CopyAtoms_withBonds.hpp
+ *
+ *  Created on: Mar 17, 2012
+ *      Author: heber
+ */
+
+#ifndef COPYATOMS_WITHBONDS_HPP_
+#define COPYATOMS_WITHBONDS_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <map>
+
+#include "Atom/CopyAtoms/CopyAtoms_Simple.hpp"
+#include "CodePatterns/Assert.hpp"
+
+class atom;
+
+/** This is an extented implementation of CopyAtoms_Simple that also copies the bonds.
+ *
+ */
+class CopyAtoms_withBonds : public CopyAtoms_Simple
+{
+public:
+  /** Destructor.
+   *
+   */
+  virtual ~CopyAtoms_withBonds()
+  {}
+
+  /** In this function we add to the copied atoms also the bonds.
+   *
+   * @param _atoms atoms to copy
+   */
+  virtual void operator()(const AtomVector &_atoms);
+
+private:
+  //!> type for lookup up man from original atoms to copied ones.
+  typedef std::map< const atom *,  atom *> LookupMap_t;
+
+  /** Internal helper to create a lookup map from original atoms to copies.
+   *
+   * This fills LookupMap.
+   *
+   * @param _atoms vector with original atoms
+   */
+  LookupMap_t createLookup(const AtomVector &_atoms)
+  {
+    LookupMap_t LookupMap;
+    AtomVector::const_iterator original_iter = _atoms.begin();
+    AtomVector::iterator copy_iter = CopiedAtoms.begin();
+    for (; original_iter != _atoms.end(); ++original_iter, ++copy_iter) {
+      ASSERT( copy_iter != CopiedAtoms.end(),
+          "CopyAtoms_withBonds::createLookup() - the number of copied atoms is insufficient.");
+  #ifndef NDEBUG
+      std::pair< LookupMap_t::iterator, bool> inserter =
+  #endif
+      LookupMap.insert( std::make_pair( *original_iter, *copy_iter ) );
+      ASSERT( (inserter.second) || (inserter.first->second == *copy_iter),
+          "CopyAtoms_withBonds::createLookup() - There is twice the same original atom for two distinct copies.");
+    }
+    ASSERT( copy_iter == CopiedAtoms.end(),
+        "CopyAtoms_withBonds::createLookup() - the number of copied atoms exceeds number of original ones.");
+    return LookupMap;
+  }
+};
+
+
+#endif /* COPYATOMS_WITHBONDS_HPP_ */
